# nomad-envoy-cli
This is the API descriptor for the Nomad Envoy API, responsible for order creation and product lists.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 0.1.2
- Build package: io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import nomad_envoy_cli 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import nomad_envoy_cli
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import nomad_envoy_cli
from nomad_envoy_cli.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = nomad_envoy_cli.OrderApi(nomad_envoy_cli.ApiClient(configuration))
store = 'store_example' # str | ID of the store.
body = nomad_envoy_cli.Order() # Order | Order details

try:
    # Create a new order
    api_response = api_instance.add_order(store, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling OrderApi->add_order: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://envoy.samarkand.io/envoy*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*OrderApi* | [**add_order**](docs/OrderApi.md#add_order) | **POST** /order/{store} | Create a new order
*OrderApi* | [**cancel_order**](docs/OrderApi.md#cancel_order) | **DELETE** /order/{store} | Attempt to cancel a created order.
*OrderApi* | [**get_order_by_field**](docs/OrderApi.md#get_order_by_field) | **GET** /order/{store} | Get a specific order.
*ProductApi* | [**add_product**](docs/ProductApi.md#add_product) | **POST** /product/{store} | Add a product to a store.
*ProductApi* | [**delete_product**](docs/ProductApi.md#delete_product) | **DELETE** /product/{store} | Remove a product from this store.
*ProductApi* | [**get_products_by_field**](docs/ProductApi.md#get_products_by_field) | **GET** /product/{store} | Get a list of products this store supplies.
*ProductApi* | [**update_product**](docs/ProductApi.md#update_product) | **PUT** /product/{store} | Update a product in a store.


## Documentation For Models

 - [Address](docs/Address.md)
 - [ApiResponse](docs/ApiResponse.md)
 - [ApiResponseConnectorResponse](docs/ApiResponseConnectorResponse.md)
 - [ApiResponseData](docs/ApiResponseData.md)
 - [Order](docs/Order.md)
 - [OrderItems](docs/OrderItems.md)
 - [Product](docs/Product.md)
 - [ProductImages](docs/ProductImages.md)
 - [ProductImagesYouzan](docs/ProductImagesYouzan.md)


## Documentation For Authorization


## AlibabaXCaKey

- **Type**: API key
- **API key parameter name**: x-ca-key
- **Location**: HTTP header

## AlibabaXCaStage

- **Type**: API key
- **API key parameter name**: x-ca-stage
- **Location**: HTTP header


## Author

paul@samarkand.global

